<?php
/* $Fuller: myprograms/htbm/web/php/categories.php,v 1.9 2002/08/05 04:11:17 fullermd Exp $ */

/* Ugly-ass hack to deal with damnfool scoping between these functions */
$buildcat=array();

function build_categories()
{
	global $debug;
	global $db;
	global $buildcat;

	# If we're in 'normal' mode, over-protect ourselves.
	if($debug!=1)
	{ $buildcat = array(); }

	/* Grab all the info from the 'categories' */
	$querystr = "SELECT cat_id,parent,name FROM categories ORDER BY name";
	$result = $db->query($querystr);

	while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	{
		$cid = $row['cat_id'];
		$parent = $row['parent'];
		$name = $row['name'];

		d_print("<!-- Adding category $cid -->\n");

		/* Register our info */
		$buildcat[$cid]['cid'] = $cid;
		$buildcat[$cid]['name'] = $name;
		$buildcat[$cid]['parent'] = $parent;
		if(!($buildcat[$cid]['has_children']))
		{ $buildcat[$cid]['has_children'] = 0; }

		if($cid!=0)
		{
			d_print("<!-- Registering $cid as child of $parent -->\n");
			$buildcat[$parent]['has_children'] = 1;
			if(!($buildcat[$parent]['children']))
			{ $buildcat[$parent]['children'] = array(); }
			array_push($buildcat[$parent]['children'], $cid);
		}
	}

	/* Sort all the 'children' elements */
	foreach($buildcat as $cid => $dummy)
	{
		$dstr = sprintf("<!-- Sorting for category %d (%s) -->\n",
				$cid, $buildcat[$cid]['name']);
		d_print($dstr);
		if($buildcat[$cid]['has_children']==0)
		{ continue; }

		/* Sort */
		usort($buildcat[$cid]['children'], "children_cmp");
	}

	return($buildcat);
}


/* Comparison function to sort children */
function children_cmp($a, $b)
{
	global $buildcat;
	$child_a = $buildcat[$a];
	$child_b = $buildcat[$b];

	$dstr = sprintf("<!-- Comparing '%s' (a) (%s) with '%s' (b) (%d) -->\n",
			$child_a['name'], $a, $child_b['name'], $b);
	d_print($dstr);

	return strcmp($child_a['name'], $child_b['name']);
}

?>
