<?php
/* $Fuller: myprograms/htbm/web/php/listkids.php,v 1.15 2002/07/21 13:39:37 fullermd Exp $ */

/* Show children */
function listkids($cid)
{
	global $admin;
	global $categories;
	global $expanders;
	global $expandids;
	global $expandall;
	global $self;
	global $db;

	$thekids = $categories[$cid]['children'];
	if(!$thekids)
	{ return; }

	d_print("<!-- Starting on children of $cid -->\n");
	print("<ul>\n");

	/* Start looking */
	foreach($thekids as $dummy => $thevalue)
	{
		d_print("<!-- Starting on child $thevalue -->\n");
		/* This probably shouldn't happen */
		if($thevalue==0)
		{ continue; }

		/* Do we have bookmarks? */
		$querystr = "SELECT cat_id FROM bookmarks WHERE cat_id='$thevalue' LIMIT 1";
		$ckbookres = $db->query($querystr);
		if(DB::isError($ckbookres))
		{ die($ckbookres->getMessage()); }
		if($ckbookres->numRows() == 1)
		{ $havemarks=1; d_print("<!-- We have bookmarks -->\n"); }

		/* Do we have kids? */
		$havekids = $categories[$thevalue]['has_children'];

		if($havekids==1 || $havemarks==1)
		{
			/* Check expansion */
			if($categories[$thevalue]['expanded'])
			{
				/* Show subparts and 'collapse' image */
				$showmore=1;
				$img="minus";
				$ialt="-";

				/* Create new expandids array without this entry */
				$newexpandids="";
				foreach($expanders as $dummy => $thisone)
				{
					if($thevalue!=$thisone)
					{
						$newexpandids .= "$thisone,";
					}
				}
				/* Trim trailing ','s */
				$newexpandids = rtrim($newexpandids, ",");
			} else {
				/* Don't show subparts */
				$showmore=0;
				$img="plus";
				$ialt="+";

				/* Preserve expansion */
				$newexpandids="$thevalue,$expandids";
				$newexpandids = rtrim($newexpandids, ",");
			}

			/* Show the image and make it a nice link */
			$tmpargs = print_get_without(array("expandids"));

			if(strlen($newexpandids)>0)
			{ $newexpandids = "&amp;expandids=$newexpandids"; }

			$indimg="<a href=\"$self?$tmpargs$newexpandids\">";
			$indimg.="<img src=\"images/$img.png\" height=\"11\" width=\"11\" alt=\"$ialt\" class=\"expcol\" />";
			$indimg.='</a>';
		}
		else
		{
			$showmore=0;
			$indimg='<img src="images/dot.png" height="11" width="11" alt="*" class="expcol" />';
		}
		print("<li class=\"nomark\">\n");
		printf("%s %s", $indimg, $categories[$thevalue]['name']);
		print("\n");

		if($admin==1)
		{
			print("<small>\n");
			printf("(%d)\n", $thevalue);
			print("(<a href=\"bmadmin.php?cat_id=$thevalue&amp;catedit=1\">");
			print("Edit category</a>)\n");
			print("(<a href=\"bmadmin.php?cat_id=$thevalue&amp;catdele=1\">");
			print("Delete category</a>)\n");
			print("</small>\n");
		}

		if($showmore==1 || $expandall==1)
		{
			/* List any child categories */
			listkids($thevalue);

			/* And list the bookmarks */
			listmarks($thevalue);
		}

		print("</li>\n");
	}

	print("</ul>\n");
}

?>
