-- categories
CREATE TABLE "categories" (
	"cat_id"		serial primary key,
	"parent"		integer NOT NULL DEFAULT 0,
	"name"			text NOT NULL
);

-- bookmarks
CREATE TABLE "bookmarks" (
	"mark_id"		serial primary key,
	"cat_id"		integer REFERENCES categories,
	"url"			text NOT NULL,
	"title"			text,
	"comment"		text,
	"created"		timestamp
);

-- users
CREATE TABLE "users" (
	"user_id"		serial primary key,
	"username"		text NOT NULL,
	"password"		text NOT NULL
);


-- Create root category
INSERT INTO categories (cat_id,parent,name) VALUES ('0','0','Bookmarks');
