<?php
/* $Fuller: myprograms/htbm/web/php/admin_bmark.php,v 1.8 2002/08/05 04:14:01 fullermd Exp $ */

/* Admin stuff for bookmarks */

/* Print out a form for new/edit bookmark */
function print_bmark_form($bminfo)
{
	global $db;

	$mark_id = $bminfo['mark_id'];
	$cat_id = $bminfo['cat_id'];
	$url = $bminfo['url'];
	$title = $bminfo['title'];
	$comment = $bminfo['comment'];

	if($mark_id>0)
	{ print("<h1>Bookmark number $mark_id</h1>\n"); }

	/* Mark info */
	/* XXX This should be prettified.  A lot. */
	?>
<ul>
<li>
URL:
<input type="text" size="70" name="url" value="<?php echo("$url")?>" />
</li>
<li>
Title:
<input type="text" size="70" name="title" value="<?php echo("$title")?>" />
</li>
<li>
Comment:
<br />
<textarea name="comment" rows="10" cols="80">
<?php echo("$comment")?>
</textarea>
</li>
<li>
Category:
<select name="cat_id">
<?php
	/* Figure out what categories we have */
	$categories = build_categories(); /* Kinda a cheat 8-) */

	/* Top level */
	print("<option selected=\"selected\" value=\"0\">");
	print("Bookmarks</option>\n");

	/* Print the rest */
	select_listkids(0,0,$categories);

	/* Done categories */
	?>
</select>
</li>
</ul>
<?php
	/* Fin */
}

/* List kids of a given cid in <select> output format */
/*
 * XXX
 * This is stolen pretty much verbatim from listkids.php.  We really
 * should find a way of merging as much as possible of these to make
 * future maintenance easier.
 */
function select_listkids($cid,$whichsel,$categories)
{
	$thekids = $categories[$cid]['children'];
	if(!$thekids)
	{ return; }

	foreach($thekids as $dummy => $thevalue)
	{
		d_print("<!-- Starting on kid $thevalue -->\n");
		if($thevalue==0)
		{ continue; }

		/* Find our distance from the 'root' */
		if($thevalue!=0)
		{
			$tmpcat = $categories[$thevalue];
			$leader = "&nbsp;";
			while($tmpcat['parent'] != 0)
			{
				$leader .= "&nbsp;";
				$mypar = $tmpcat['parent'];
				$tmpcat = $categories[$mypar];
			}
		}

		/* Should we be selected? */
		if($thevalue==$whichsel)
		{ $seld = " selected=\"selected\""; }
		else
		{ $seld = ""; }

		/* Print ourselves out */
		$myname = $categories[$thevalue]['name'];
		print("<option value=\"$thevalue\"$seld>$leader$myname</option>\n");

		/* Do we have children? */
		$havekids = $categories[$thevalue]['has_children'];

		if($havekids)
		{
			select_listkids($thevalue,$whichsel,$categories);
		}
	}
}
